
####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was Config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

# provide meta-data
set(c++utilities_varname "CPP_UTILITIES")
set(c++utilities_static_varname "CPP_UTILITIES")
set(CPP_UTILITIES_DISPLAY_NAME "C++ Utilities")
set(CPP_UTILITIES_AUTHOR "Martchus")
set(CPP_UTILITIES_VERSION "4.16.0")
set(CPP_UTILITIES_VERSION_MAJOR "4")
set(CPP_UTILITIES_VERSION_MINOR "16")
set(CPP_UTILITIES_VERSION_PATCH "0")
set(CPP_UTILITIES_GIT_REV_COUNT "")
set(CPP_UTILITIES_GIT_LAST_COMMIT_ID "")
set(CPP_UTILITIES_URL "https://github.com/Martchus/c++utilities")
set(CPP_UTILITIES_DESCRIPTION "Useful C++ classes and routines such as argument parser, IO and conversion utilities")
set(CPP_UTILITIES_LICENSE "GPL-2")

# define general config
set(CPP_UTILITIES_IS_HEADER_ONLY NO)
set(CPP_UTILITIES_HAS_SHARED_LIB ON)
set(CPP_UTILITIES_HAS_STATIC_LIB OFF)
set(CPP_UTILITIES_INCLUDE_DIRS "${PACKAGE_PREFIX_DIR}/include")
set(CPP_UTILITIES_BIN_DIR "${PACKAGE_PREFIX_DIR}/bin")
set(CPP_UTILITIES_LIB_DIR "${PACKAGE_PREFIX_DIR}/lib64")
set(CPP_UTILITIES_MODULE_DIRS "${PACKAGE_PREFIX_DIR}/share/c++utilities/cmake/modules")
set(CPP_UTILITIES_CONFIG_DIRS "${PACKAGE_PREFIX_DIR}/share/c++utilities/cmake")
set(CPP_UTILITIES_PRIVATE_QT_MODULES "")
set(CPP_UTILITIES_PRIVATE_KF_MODULES "")
set(CPP_UTILITIES_PUBLIC_QT_MODULES "")
set(CPP_UTILITIES_PUBLIC_KF_MODULES "")
set(CPP_UTILITIES_HAS_QT_TRANSLATION_FILES )
set(CPP_UTILITIES_QT_RESOURCES )

# include files for shared/static specific configuration
set(CPP_UTILITIES_HAS_SHARED_LIB NO)
set(CPP_UTILITIES_HAS_STATIC_LIB NO)
file(GLOB CPP_UTILITIES_SPECIFIC_CONFIG_FILES
    LIST_DIRECTORIES OFF
    "${CMAKE_CURRENT_LIST_DIR}/c++utilities?*Config.cmake"
)
foreach(SPECIFIC_CONFIG_FILE IN LISTS CPP_UTILITIES_SPECIFIC_CONFIG_FILES)
    include("${SPECIFIC_CONFIG_FILE}")
endforeach()
unset(SPECIFIC_CONFIG_FILE)

# set default target: prefer shared lib over static lib
if(CPP_UTILITIES_HAS_SHARED_LIB)
    set(CPP_UTILITIES_LIB "c++utilities")
else()
    set(CPP_UTILITIES_LIB "c++utilities_static")
endif()

# define macro to ease use of library in projects following conventions of c++utilities' build script
macro(use_CPP_UTILITIES)
    # make CMake modules of the project available
    list(APPEND CMAKE_MODULE_PATH ${CPP_UTILITIES_MODULE_DIRS})
    # link against library (also "link" against header-only libs to get compile defs and interface link libs)
    link_directories(${CPP_UTILITIES_LIB_DIR})
    include(3rdParty)
    if(NOT ARGV0)
        set(CPP_UTILITIES_LINKAGE AUTO_LINKAGE)
    else()
        set(CPP_UTILITIES_LINKAGE "${ARG0}")
    endif()
    link_against_library(CPP_UTILITIES "${CPP_UTILITIES_LINKAGE}" REQUIRED)
    # add required Qt and KF modules
    list(APPEND IMPORTED_QT_MODULES
        ${CPP_UTILITIES_PUBLIC_QT_MODULES}
        ${CPP_UTILITIES_PRIVATE_QT_MODULES}
    )
    list(APPEND IMPORTED_KF_MODULES
        ${CPP_UTILITIES_PUBLIC_KF_MODULES}
        ${CPP_UTILITIES_PRIVATE_KF_MODULES}
    )
    # add required translations to APP_SPECIFIC_QT_TRANSLATION_FILES_ARRAY
    if(CPP_UTILITIES_HAS_QT_TRANSLATION_FILES)
        list(APPEND APP_SPECIFIC_QT_TRANSLATION_FILES c++utilities)
    endif()
endmacro()
